package cz.cvut.fit.swing.calipel.benchmarks;

// $Id: Ary.java,v 1.3 2013-09-06 00:41:36 vrany Exp $
// http://www.bagley.org/~doug/shootout/

// this program is modified from:
//   http://cm.bell-labs.com/cm/cs/who/bwk/interps/pap.html
// Timing Trials, or, the Trials of Timing: Experiments with Scripting
// and User-Interface Languages</a> by Brian W. Kernighan and
// Christopher J. Van Wyk.

import java.util.HashMap;

@SuppressWarnings("unused")
public class BenchmarkMicro {

    @SuppressWarnings("unused")
    public void ary() {
        int n = 1000000;
        int i;
        int j;
        int k;
        int x[] = new int[n];
        int y[] = new int[n];

        for (i = 0; i < n; i++)
            x[i] = i + 1;
        for (k = 0; k < 1000; k++)
            for (j = n - 1; j >= 0; j--)
                y[j] += x[j];
    }

    @SuppressWarnings("unused")
    public void hsh() {
        int n = 1000000;
        int i, c;

        HashMap<String, Integer> ht = new HashMap<String, Integer>();
        c = 0;
        for (i = 1; i <= n; i++)
            ht.put(Integer.toString(i, 16), new Integer(i));
        for (i = 1; i <= n; i++) {
            if (ht.containsKey(Integer.toString(i, 10))) {
                c++;
            }
        }
    }

    @SuppressWarnings("unused")
    public void strcat() {
        int n = 1000000;
        String hello = "hello\n";
        StringBuffer stringBuffer = new StringBuffer(32);
        for (int i = 0; i < n; i++) {
            stringBuffer.append(hello);
        }
    }

    @SuppressWarnings("unused")
    public void ackermann(int num) {
        ackRecursive(3, num);
    }

    private int ackRecursive(int m, int n) {
        if (m == 0) {
            return n + 1;
        } else {
            if (n == 0) {
                return ackRecursive(m - 1, 1);
            } else {
                return ackRecursive(m - 1, ackRecursive(m, n - 1));
            }
        }
    }
}

