"{ Package: 'jv:calipel/s/benchmarks/micro' }"

LibraryDefinition subclass:#jv_calipel_s_benchmarks_micro
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jv_calipel_s_benchmarks_micro class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of jv_calipel_s_benchmarks_micro"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for loading or compiling.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
        #'jv:calipel/s'    "BenchmarkInstance - referenced by BenchmarkMicro class>>run:"
        #'stx:libbasic2'    "Random - referenced by BenchmarkPerform class>>initialize"
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!jv_calipel_s_benchmarks_micro class methodsFor:'description - actions'!

postLoadAction
    "invoked after loading a project"

    Smalltalk silentlyLoadingDo: [ 
        self classes do:[:cls | cls autoload ].
    ].

    "Created: / 14-07-2013 / 16:50:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_calipel_s_benchmarks_micro class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (BenchmarkMicro autoload)
        BenchmarkMicroStringConcat
        BenchmarkMicroStringConcatN
        BenchmarkPerform
        #'jv_calipel_s_benchmarks_micro'
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
    )
! !

!jv_calipel_s_benchmarks_micro class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'My Company'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'My CopyRight or CopyLeft'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'LibraryName'
! !

!jv_calipel_s_benchmarks_micro methodsFor:'description - actions'!

postLoadAction
    "invoked after loading a project"

    Smalltalk silentlyLoadingDo: [ 
        self classes do:[:cls | cls autoload ].
    ].

    "Created: / 14-07-2013 / 16:50:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_calipel_s_benchmarks_micro class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

