class ImportsController < ApplicationController

  skip_before_filter :verify_authenticity_token, only: :push_import
  before_filter :add_example_json

  def show_text_import
    @text_import_query = TextImportQuery.new
  end

  def show_file_import
    @file_import_query = FileImportQuery.new
  end

  def show_post_import
  end

  def text_import
    @text_import_query = TextImportQuery.new(text_import_params)

    if @text_import_query.valid?
      @text_import_query.store!
      flash[:success] = "Data successfully stored"
      redirect_to imports_root_path
    else
      flash.now[:error] = "Data couldn't be stored"
      render "show_text_import"
    end
  end

  def file_import
    @file_import_query = FileImportQuery.new(file_import_params)

    if @file_import_query.valid?
      @file_import_query.store!
      flash[:success] = "Data successfully stored"
      redirect_to imports_root_path
    else
      flash.now[:error] = "Data couldn't be stored"
      render "show_file_import"
    end
  end

  def push_import
    if request.content_type == "application/json"
      @import_query = JsonImportQuery.new(
        json: params[:import])
    else
      @import_query = TextImportQuery.new(
        text: params[:import])
    end

    if @import_query.valid?
      @import_query.store!
      head :ok
    else
      head :bad_request
    end
  end

  private

  def text_import_params
    params.require(:text_import_query).permit(:text)
  end

  def file_import_params
    params.require(:file_import_query).permit(:file)
  end

  def add_example_json
    @example_json = "\n#{EXAMPLE_JSON_PRETTY_PRINTED}"
  end
end
